# Newsthing is a python script written by Scott Hather 
# http://scotthather.weebly.com
# It's the script for my conky that grabs the latest news from Reuters and
# displays the headlines. It caches the news, so only hits their server once an hour.
# DEPENDANCY: It uses standard python libraries, except one that you'll need to 
# install, open terminal and type:
#
# sudo pip install feedparser
#
# unzip everything into your "~/.conky/NewsThing" folder, so you should have 3 files, the conky config file, a jpg preview and this python script
# I would then suggest you install "conky-manager" package to add it to your existing desktop setup.
# This comes with NO WARRENTY. Feel free to improve this script, but please don't just steal it and call it your own work!
# I can see you...and I know where you live :-)

#!/usr/bin/python3
from subprocess import call
from subprocess import check_output
import feedparser,json,time, os,random
import datetime

#could probably use "." as the folder name eh?
refreshCache=False
pwd=check_output("pwd",shell=True).decode("UTF-8").replace("\n","")+"/"

# no cache, so definitely refresh it
if os.path.isfile(pwd+"newscache.xml")==False:
	refreshCache=True
else: #there is a cache, so check if it's older than an hour
	tsf=int(os.path.getmtime(pwd+"newscache.xml")) # unix ts of the file (seconds not ms)
	age=int(time.time()) - tsf
	if age > (60*60):
		refreshCache=True

# ok, so the cache needs refreshing, go hit the Reuters news server...
if refreshCache:
	print("Getting latest world news!")
	call("rm -f "+pwd+"newscache.xml",shell=True) #I remove the old cache as I noticed it sometimes won't over-write
	call("wget --no-cache -t 3 -U newsthing --no-dns-cache --no-cookies -O "+pwd+"newscache.xml \"http://feeds.reuters.com/reuters/worldNews\"",shell=True)

rss=feedparser.parse(pwd+"newscache.xml")
items=len(rss['entries'])
if items==0: #if you're internet goes down...
	print("No news items! is the internet broke or has the world come to an end?")
	os.exit()
else:
	r=random.randrange(0,items) #no persistance, so just pick a random headline
	item=rss['entries'][r]
	loc=item['summary']
	loc=loc[0:loc.find(" (")] #this relies on Reuters using the standard formatting of "<PLACE NAME> (Reuters) Blah...." from the summary field
	
	#if you change RSS feed, they may use a different date format, so this line will need altering
	publishedTS=int(time.mktime(datetime.datetime.strptime(item['published'].replace(" GMT",""),"%a, %d %b %Y %H:%M:%S").timetuple()))
	now=int(time.time())
	minsago=(now-publishedTS)/60
	if minsago<60:
		age=str(int(minsago))+" minutes ago"
	elif minsago<120:
		age="1 hour ago"
	else:
		age=str(int(minsago/60))+" hours ago"
	# age now contains how old the article is
	
	# finally, print the news location, the headline and the age of the news story on screen
	print(loc+": "+item['title'])
	print(age)
